clc
clear all
close all

%%

filepattern = fullfile('NETCDF', '*.nc');
ncfiles = dir(filepattern);                      % Names of all the nc-files
ne = length(ncfiles);                            % Number of nc-files found

% Get lenght of the signals
filename = ['NETCDF/',ncfiles(1).name];
signal_real = ncread(filename,'SIGNAL REAL') ;
[ns,na] = size(signal_real);                     % ns: number of time samples
                                                 % na: number of angles
% Initialize array to store all signals:
S = zeros(ns,na,ne);

% Get size of the phantoms:
phantom  = ncread(filename,'PHANTOM') ;
[nx,ny] = size(phantom);                         % nx: pixels in x-direction
                                                 % ny: pixels in y-direction
% Initialize array to store all phantoms:
phantoms = zeros(nx,ny,ne);
 
%% Read the measurements
for k = 1:ne
   filename = ['NETCDF/',ncfiles(k).name];
   signal_real = ncread(filename,'SIGNAL REAL') ;
   signal_imag = ncread(filename,'SIGNAL IMAG') ;
   signal = signal_real + 1i*signal_imag;
   S(:,:,k)= signal(:,:);
   phantom  = ncread(filename,'PHANTOM') ;
   phantoms(:,:,k) = phantom;
end

k = input('k= ');
A = reshape(abs(S),[ns*na,ne]);
b = A(:,k);
A(:,k) = 0;
[U,SIGMA,V] = svd(A,0);
x = zeros(ne,1);
for i = 1:ne-1
   x = x + (1/SIGMA(i,i))*V(:,i)*dot(U(:,i),b);
end

IM = zeros(nx,ny);
s = zeros(ns*na,1);
for i = 1:ne
   s = s + x(i)*A(:,i);
   IM = IM + x(i)*phantoms(:,:,i);
end
figure;
imagesc(abs(IM));
figure;
imagesc(phantoms(:,:,k));
figure;
plot(real(b),'b');
hold on;
plot(real(s),'r');
return
